/*
 * MIT License
 *
 * Copyright (c) 2018-2019 Daniel Cortes
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package danielcortes.xyz.models.egreso;

import danielcortes.xyz.data.SQLiteConnectionHolder;
import danielcortes.xyz.models.caja.Caja;
import danielcortes.xyz.models.tipo_egreso.TipoEgreso;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.time.LocalDate;
import java.time.YearMonth;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

public class SQLiteEgresoDAO extends EgresoDAO {
    private static final Logger LOGGER = Logger.getLogger(SQLiteEgresoDAO.class.getName());

    public SQLiteEgresoDAO() {
        this.connectionHolder = new SQLiteConnectionHolder();
    }

    @Override
    public List<Egreso> findAll() {
        List<Egreso> egresoList = new ArrayList<>();
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "select * from egresos";
            PreparedStatement ps = conn.prepareStatement(query);
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0}", query);

            egresoList = this.egresosFromResultSet(rs);

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
        }
        return egresoList;
    }

    @Override
    public List<Egreso> findById(int id) {
        List<Egreso> egresoList = new ArrayList<>();
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "select * from egresos where id = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, id);
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1}", new Object[]{query, id});

            egresoList = this.egresosFromResultSet(rs);

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
        }
        return egresoList;
    }

    @Override
    public List<Egreso> findByCaja(Caja caja) {
        List<Egreso> egresoList = new ArrayList<>();
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "select * from egresos where caja_id = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, caja.getId());
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1}", new Object[]{query, caja.getId()});

            egresoList = this.egresosFromResultSet(rs);

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
        }
        return egresoList;
    }

    @Override
    public List<Egreso> findByNro(String nro) {
        List<Egreso> egresoList = new ArrayList<>();
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "select * from egresos where nro = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setString(1, nro);
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0} | values {1}", new Object[]{query, nro});

            egresoList = this.egresosFromResultSet(rs);

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
        }
        return egresoList;
    }

    @Override
    public List<Egreso> findByTipoEgreso(TipoEgreso tipoEgreso) {
        List<Egreso> egresoList = new ArrayList<>();
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "select * from egresos where tipo_egreso_id = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, tipoEgreso.getId());
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1}", new Object[]{query, tipoEgreso.getId()});

            egresoList = this.egresosFromResultSet(rs);

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
        }
        return egresoList;
    }

    @Override
    public boolean insertEgreso(Egreso egreso) {
        int updates;
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "insert into egresos (nro, descripcion, valor, tipo_egreso_id, caja_id) values (?,?,?,?,?)";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setString(1, egreso.getNro());
            ps.setString(2, egreso.getDescripcion());
            ps.setInt(3, egreso.getValor());
            ps.setInt(4, egreso.getTipoEgreso().getId());
            ps.setInt(5, egreso.getCaja().getId());
            updates = ps.executeUpdate();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: [{1}, {2}, {3}, {4}, {5}] | updates: {6}", new Object[]{query, egreso.getNro(), egreso.getDescripcion(), egreso.getValor(), egreso.getTipoEgreso().getId(), egreso.getCaja().getId(), updates});

            ps.close();

            ps = conn.prepareStatement("select last_insert_rowid()");
            ResultSet rs = ps.executeQuery();
            rs.next();
            egreso.setId(rs.getInt(1));

            rs.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
            return false;
        }
        return updates > 0;
    }

    @Override
    public boolean updateEgreso(Egreso egreso) {
        int updates;
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "update egresos set nro = ?, descripcion = ?, valor = ?, tipo_egreso_id = ?, caja_id = ? where id = ? ";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setString(1, egreso.getNro());
            ps.setString(2, egreso.getDescripcion());
            ps.setInt(3, egreso.getValor());
            ps.setInt(4, egreso.getTipoEgreso().getId());
            ps.setInt(5, egreso.getCaja().getId());
            ps.setInt(6, egreso.getId());
            updates = ps.executeUpdate();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: [{1}, {2}, {3}, {4}, {5}, {6}] | updates: {7}", new Object[]{query, egreso.getNro(), egreso.getDescripcion(), egreso.getValor(), egreso.getTipoEgreso().getId(), egreso.getCaja().getId(), egreso.getId(), updates});


            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
            return false;
        }
        return updates > 0;
    }

    @Override
    public boolean deleteEgreso(Egreso egreso) {
        int updates;
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "delete from egresos where id = ? ";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, egreso.getId());
            updates = ps.executeUpdate();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1} | updates: {2}", new Object[]{query, egreso.getId(), updates});

            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
            return false;
        }
        return updates > 0;
    }

    @Override
    public int getTotalEgreso(Caja caja) {
        int total = 0;
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "select sum(valor) from egresos where caja_id = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, caja.getId());
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1}", new Object[]{query, caja.getId()});

            rs.next();
            total = rs.getInt(1);

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
        }
        return total;
    }

    @Override
    public int getTotalEgresoMesPorTipo(YearMonth mes, TipoEgreso tipo) {
        int total = 0;
        try (Connection conn = connectionHolder.getConnection()) {
            LocalDate start = mes.atDay(1);
            LocalDate end = mes.atEndOfMonth();
            String query = "select sum(valor) from egresos inner join caja on (egresos.caja_id = caja.id) where fecha between ? and ? and tipo_egreso_id = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setString(1, start.toString());
            ps.setString(2, end.toString());
            ps.setInt(3, tipo.getId());
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1}, {2}, {3}", new Object[]{query, start, end, tipo});

            rs.next();
            total = rs.getInt(1);

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
        }
        return total;
    }


}
